package com.partisiablockchain.language.partisiacli;

/*
 * Copyright (C) 2022 - 2023 Partisia Blockchain Foundation
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

import com.partisiablockchain.language.partisiacli.executionenvironment.ClientProviderMain;
import com.partisiablockchain.language.partisiacli.executionenvironment.ExecutionEnvironment;
import com.partisiablockchain.language.partisiacli.executionenvironment.FileManager;
import com.partisiablockchain.language.partisiacli.parser.Blockchain;
import com.secata.tools.coverage.ExceptionConverter;
import java.io.PrintWriter;
import java.nio.file.Paths;
import java.security.SecureRandom;
import java.util.List;
import java.util.Map;
import picocli.CommandLine;

/** Holds the main-method of the CLI and the pseudo-main method used for dependency injections. */
public final class Main {

  private Main() {}

  /**
   * Runs the command-line given by the arguments. If the input is invalid, a help message will be
   * printed. If any {@link RuntimeException} occurs during execution, the program terminates with a
   * minimal error message.
   *
   * @param args The arguments describing a command.
   */
  public static void main(String[] args) {
    FileManager fileManager = new FileManager(Paths.get(""));
    runCommandLine(
        args,
        new CommandLine(new Blockchain()),
        new ExecutionEnvironment(
            new ClientProviderMain(),
            System.out,
            System.in,
            System.err,
            System::exit,
            fileManager,
            new SecureRandom(),
            Paths.get(System.getProperty("user.home") + "/.pbc/config.json"),
            Paths.get(System.getProperty("user.home") + "/.pbc/id_pbc")));
  }

  /**
   * The pseudo-main method of the command-line interface, see {@link Main#main}. The purpose of the
   * method is to allow for dependency injection during testing. Validates the command-line
   * arguments and passes the result of parsing them to {@link CommandExecutor}.
   *
   * @param args The arguments of the main-method.
   * @param commandLine The command-line object holding the initialized records, corresponding to
   *     the args.
   * @param executionEnvironment The dependencies of the command-line being run.
   */
  public static void runCommandLine(
      String[] args, CommandLine commandLine, ExecutionEnvironment executionEnvironment) {
    commandLine.setOut(new PrintWriter(executionEnvironment.out()));
    commandLine.setErr(new PrintWriter(executionEnvironment.err()));

    if (args.length == 0) {
      commandLine.usage(commandLine.getOut());
      return;
    }

    try {
      // Validate args
      CommandLine.ParseResult parseResult = commandLine.parseArgs(args);
      Integer helpExitCode = CommandLine.executeHelpRequest(parseResult);
      if (helpExitCode != null) {
        return;
      }
      checkForSubcommands(parseResult);

      CommandExecutor commandExecutor = new CommandExecutor(executionEnvironment);
      commandExecutor.execute(parseResult);
    } catch (CommandLine.ParameterException ex) {
      executionEnvironment
          .terminationStrategy()
          .exit(
              ExceptionConverter.call(
                  () -> commandLine.getParameterExceptionHandler().handleParseException(ex, args)));
    } catch (Exception ex) {
      executionEnvironment.err().println(ex.getMessage());
      executionEnvironment.terminationStrategy().exit(1);
    }
  }

  /**
   * Checks that all required subcommands are present in the input to the command-line. This is
   * achieved by running through each layer of the tree of commands generated by Picocli and looking
   * for a valid path, in a greedy fashion, to some leaf. A path is valid if for all layers, a CLI
   * input matched a command on that layer. Enforcement of the correct sequence of subcommands is
   * ensured by the structure of the provided {@link picocli.CommandLine.ParseResult}.
   *
   * @param parseResult The object containing information about the parsed input.
   */
  private static void checkForSubcommands(CommandLine.ParseResult parseResult) {
    List<String> originalArgs = parseResult.originalArgs();
    CommandLine commandLine = parseResult.commandSpec().commandLine();
    while (true) {
      Map<String, CommandLine> subcommandLayer = commandLine.getSubcommands();
      if (subcommandLayer.isEmpty()) {
        return;
      }

      // Has to find a match from subcommands.keySet() at this point in execution
      boolean foundSubcommandMatch = false;
      for (String subcommand : subcommandLayer.keySet()) {
        foundSubcommandMatch = findSubcommandMatch(originalArgs, subcommand);
        if (foundSubcommandMatch) {
          commandLine = subcommandLayer.get(subcommand);
          break;
        }
      }
      if (!foundSubcommandMatch) {
        throw new CommandLine.ParameterException(commandLine, "Missing required subcommand");
      }
    }
  }

  private static boolean findSubcommandMatch(List<String> originalArgs, String argToMatch) {
    return originalArgs.stream().anyMatch(arg -> arg.equals(argToMatch));
  }
}
